Index: src/libpspp/message.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/libpspp/message.c,v
retrieving revision 1.5
diff -u -p -u -r1.5 message.c
--- src/libpspp/message.c	8 Jul 2006 03:05:52 -0000	1.5
+++ src/libpspp/message.c	17 Jul 2006 04:09:55 -0000
@@ -21,6 +21,7 @@
 
 #include <libpspp/message.h>
 
+#include <assert.h>
 #include <stdarg.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -41,6 +42,9 @@ static void (*msg_handler)  (const struc
 static void (*msg_location) (struct msg_locator *);
 
 
+/* Disables emitting messages if positive. */
+static int messages_disabled;
+
 /* Public functions. */
 
 /* Writes error message in CLASS, with text FORMAT, formatted with
@@ -93,16 +97,34 @@ msg_destroy(struct msg *m)
   free(m);
 }
 
-
 /* Emits M as an error message.
    Frees allocated data in M. */
 void
 msg_emit (struct msg *m) 
 {
   msg_location (&m->where);
-  msg_handler (m);
+  if (!messages_disabled)
+    msg_handler (m);
   free (m->text);
 }
+
+/* Disables message output until the next call to msg_enable.  If
+   this function is called multiple times, msg_enable must be
+   called an equal number of times before messages are actually
+   re-enabled. */
+void
+msg_disable (void) 
+{
+  messages_disabled++;
+}
+
+/* Enables message output that was disabled by msg_disable. */
+void
+msg_enable (void) 
+{
+  assert (messages_disabled > 0);
+  messages_disabled--;
+}
 
 /* Private functions. */
 
Index: src/libpspp/message.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/libpspp/message.h,v
retrieving revision 1.12
diff -u -p -u -r1.12 message.h
--- src/libpspp/message.h	8 Jul 2006 03:05:52 -0000	1.12
+++ src/libpspp/message.h	17 Jul 2006 04:09:55 -0000
@@ -99,6 +99,10 @@ void msg (enum msg_class, const char *fo
      PRINTF_FORMAT (2, 3);
 void msg_emit (struct msg *);
 
+/* Enable and disable messages. */
+void msg_enable (void);
+void msg_disable (void);
+
 /* Error context. */
 void msg_set_command_name (const char *);
 const char *msg_get_command_name (void);
Index: src/libpspp/str.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/libpspp/str.c,v
retrieving revision 1.14
diff -u -p -u -r1.14 str.c
--- src/libpspp/str.c	15 Jul 2006 22:39:18 -0000	1.14
+++ src/libpspp/str.c	17 Jul 2006 04:09:56 -0000
@@ -27,6 +27,7 @@
 
 #include <libpspp/alloc.h>
 #include <libpspp/message.h>
+#include <libpspp/pool.h>
 
 #include "minmax.h"
 #include "size_max.h"
@@ -676,6 +677,30 @@ ds_swap (struct string *a, struct string
   *b = tmp;
 }
 
+/* Helper function for ds_register_pool. */
+static void
+free_string (void *st_) 
+{
+  struct string *st = st_;
+  ds_destroy (st);
+}
+
+/* Arranges for ST to be destroyed automatically as part of
+   POOL. */
+void
+ds_register_pool (struct string *st, struct pool *pool) 
+{
+  pool_register (pool, free_string, st);
+}
+
+/* Cancels the arrangement for ST to be destroyed automatically
+   as part of POOL. */
+void
+ds_unregister_pool (struct string *st, struct pool *pool)
+{
+  pool_unregister (pool, st);
+}
+
 /* Copies SRC into DST.
    DST and SRC may be the same string. */
 void
@@ -860,6 +885,18 @@ ds_rpad (struct string *st, size_t lengt
     ds_put_char_multiple (st, pad, length - st->ss.length);
 }
 
+/* Sets the length of ST to exactly NEW_LENGTH,
+   either by truncating characters from the end,
+   or by padding on the right with PAD. */
+void
+ds_set_length (struct string *st, size_t new_length, char pad)
+{
+  if (st->ss.length < new_length)
+    ds_rpad (st, new_length, pad);
+  else
+    st->ss.length = new_length;
+}
+
 /* Returns true if ST is empty, false otherwise. */
 bool
 ds_is_empty (const struct string *st) 
Index: src/libpspp/str.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/libpspp/str.h,v
retrieving revision 1.10
diff -u -p -u -r1.10 str.h
--- src/libpspp/str.h	9 Jun 2006 22:51:24 -0000	1.10
+++ src/libpspp/str.h	17 Jul 2006 04:09:56 -0000
@@ -151,6 +151,11 @@ void ds_init_cstr (struct string *, cons
 void ds_destroy (struct string *);
 void ds_swap (struct string *, struct string *);
 
+/* Pools. */
+struct pool;
+void ds_register_pool (struct string *, struct pool *);
+void ds_unregister_pool (struct string *, struct pool *);
+
 /* Replacement. */
 void ds_assign_string (struct string *, const struct string *);
 void ds_assign_substring (struct string *, struct substring);
@@ -172,6 +177,7 @@ bool ds_separate (const struct string *s
 bool ds_tokenize (const struct string *src, struct substring delimiters,
                   size_t *save_idx, struct substring *token);
 void ds_rpad (struct string *, size_t length, char pad);
+void ds_set_length (struct string *, size_t new_length, char pad);
 
 /* Extracting substrings. */
 struct substring ds_ss (const struct string *);
Index: tests/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/tests/ChangeLog,v
retrieving revision 1.60
diff -u -p -u -r1.60 ChangeLog
--- tests/ChangeLog	12 Jul 2006 17:09:19 -0000	1.60
+++ tests/ChangeLog	17 Jul 2006 04:09:56 -0000
@@ -1,3 +1,7 @@
+Sun Jul 16 21:08:51 2006  Ben Pfaff  <blp@gnu.org>
+
+	* command/print.sh: Update output to match PRINT revisions.
+
 Wed Jul 12 10:07:52 2006  Ben Pfaff  <blp@gnu.org>
 
 	* automake.mk: Put ll-test, llx-test in check_PROGRAMS instead of
Index: tests/command/print.sh
===================================================================
RCS file: /cvsroot/pspp/pspp/tests/command/print.sh,v
retrieving revision 1.24
diff -u -p -u -r1.24 print.sh
--- tests/command/print.sh	30 May 2006 12:01:34 -0000	1.24
+++ tests/command/print.sh	17 Jul 2006 04:09:57 -0000
@@ -120,11 +120,11 @@ diff -b  $TEMPDIR/pspp.list - << EOF
 |Variable|Record|Columns|Format|
 #========#======#=======#======#
 |A       |     1|  1-  8|F8.2  |
-|"/"     |     1|  9-  9|A1    |
+|"/"     |     1|  9-  9|      |
 |B       |     1| 10- 17|E8.2  |
-|"/"     |     1| 18- 18|A1    |
+|"/"     |     1| 18- 18|      |
 |C       |     1| 19- 28|N10.0 |
-|"/"     |     1| 29- 29|A1    |
+|"/"     |     1| 29- 29|      |
 +--------+------+-------+------+
        A        B        C        D
 -------- -------- -------- --------
